from common import *



class Coldic:
	font=black
	important=red
	classe=Color(0.06,0.21,0.46)
	inst=Color(0.78,0.29,0.65)
	precision=Color(0.96,0.60,0.04)
	precision2=Color(0.51,0.34,0.02)
	terrain=Color(188/255.0,177/255.0,20/255.0)
	grass=green
	memoire=blue
	comment=Color(0.7,0.7,0.7)
	lod3=Color(1.0,0.0,1.0)
	lod2_5=Color(0.6,0.0,1.0)
	lod2=Color(0.1,0.0,1.0)

coldic=Coldic()
epsilon=0.001
textSize=0.053
titleSize=0.07

# camera dicitonnary
cams={}
cams["start"]=Rect(-1000,-1000,1000,1000)
cams["default"]=Rect(-1000,-1000,1000,1000)
cams["current"]=cams["start"]


def get_cams(s):
	if not s in cams:
		cams[s]=cams["default"]
	return cams[s].restrict_aspect(window_aspect())

def wfunc(canva):
	return canva.height()*0.005

# image dicitonnary
ims={}
ims["adn"]=load_image("adn.jpg")
ims["occ"]=load_image("occ_query.png")
ims["doigt"]=load_image("doigt.png")
ims["nez"]=load_image("nez.png")
ims["torus"]=load_image("torus.jpg")
ims["oreille"]=load_image("oreille.png")
ims["langue"]=load_image("langue.png")
ims["oeil"]=load_image("oeil.png")
ims["oeil2"]=load_image("oeil2.png")
ims["sapin1"]=load_image("sapin_loin.png")
ims["sapin2"]=load_image("sapin_pres.png")
ims["multi_scene"]=load_image("multi_scene.png")
ims["ecran"]=load_image("ecran.png")
ims["createur"]=load_image("createur.png")
ims["arbre0"]=load_image("arbre-niveau0.png")
ims["arbre1"]=load_image("arbre-niveau1.png")
ims["arbre2"]=load_image("arbre-niveau2.png")
ims["nedit"]=load_image("nedit.png")
ims["menubar"]=load_image("menubar.png")
ims["son"]=load_image("son.png")
ims["rature"]=load_image("rature.png")
ims["avion"]=load_image("avion.png")
ims["avionBB1"]=load_image("avionBB.png")
ims["avionBB2"]=load_image("avionBB2.png")
ims["f3"]=load_image("f3.gif")
ims["f4"]=load_image("f4.gif")
ims["ifs"]=load_image("0.gif")
ims["lsys"]=load_image("1.gif")

#ims["Australia"]=load_image("particulier/Australia.jpg")
#ims["fur"]=load_image("particulier/fur.jpg")
#ims["ocean"]=load_image("particulier/ocean.jpg")
#ims["orbits"]=load_image("particulier/orbits.jpg")
#ims["pin"]=load_image("particulier/pin.jpg")
#ims["prairie1.jpg"] =load_image("particulier/prairie1.jpg")
#ims["surfel"]=load_image("particulier/surfel.jpg")
#ims["terrain"]=load_image("particulier/terrain.jpg")
#ims["ville"]=load_image("particulier/ville.jpg")

#ims["fractal"]=load_image("fractal.png")

ims["bw1"]=load_image("bw/bw1.jpg")
ims["bw2"]=load_image("bw/bw2.jpg")
ims["bw3"]=load_image("bw/bw3.jpg")

ims["cubeanim"]=[
	load_image("cubeanim0.png"),
	load_image("cubeanim1.png"),
	load_image("cubeanim2.png"),
	load_image("cubeanim3.png")
]




ims["prairieExp.jpg"]=load_image("prairieExp.jpg")
ims["mojo"]=load_image("particulier/mojo.jpg")
ims["prairie1"]=load_image("particulier/ville.jpg")
ims["ville"]=load_image("particulier/prairie1.jpg")
ims["Australia"]=load_image("particulier/Australia.jpg")
ims["pin"]=load_image("particulier/pin.jpg")
ims["terrain"]=load_image("particulier/terrain.jpg")
ims["ocean"]=load_image("particulier/ocean.jpg")
ims["surfel"]=load_image("particulier/surfel.jpg")
ims["xavier"]=load_image("particulier/xavier.png")

particulier_txt={}
particulier_txt["prairie1"]="[Parish03]"
particulier_txt["ville"]="[Guerraz02]"

particulier_txt["Australia"]="[Celestia01]"
particulier_txt["pin"]="[Meyer98]"
#particulier_txt["orbits"]="[Celestia]"
particulier_txt["mojo"]="[Musgrave89]"
particulier_txt["xavier"]="[Baele03]"

particulier_txt["ocean"]="[Hinsinger02]"
#particulier_txt["fur"]="[Lengyel01]"
particulier_txt["surfel"]="[Stamminger01]"

xfig_particulier=XfigFrame()
xfig_particulier.load("./particulier/etatart.fig")
xfig_particulier2=XfigFrame()
xfig_particulier2.load("./particulier/etatart2.fig")

xfig_prairie=XfigFrame()
xfig_prairie.load("./prairie.fig")

ims["select3.jpg"]=load_image("./gui/select3.jpg")
ims["tab.jpg"]=load_image("./tab.jpg")

ims["debugPanel.jpg"]=load_image("./gui/debugPanel.jpg")
ims["secobbis.jpg"]=load_image("./gui/secobbis.jpg")
ims["dgtree7.jpg"]=load_image("./gui/dgtree7.jpg")
txt_gui={}
txt_gui["debugPanel.jpg"]="Valeurs paramtres"
txt_gui["secobbis.jpg"]="Autre point de vue"
txt_gui["dgtree7.jpg"]="Visualisation"
xfig_gui=XfigFrame()
xfig_gui.load("./gui/toto.fig")

xfig_mod=XfigFrame()
xfig_mod.load("./gui.fig")

ims["joliecube.png"]=load_image("./bandeAfig/joliecube.png")
ims["with_occ.png"]=load_image("./bandeAfig/with_occ.png")
ims["without_occ.png"]=load_image("./bandeAfig/without_occ.png")
xfig_bande=XfigFrame()
xfig_bande.load("./bandeAfig/cube.fig")

#replace
#(\w+)\.png ([0-9]+) ([0-9]+) ([0-9]+) ([0-9]+) ([0-9]+) ([0-9]+)
#xfig_mod.listBox["\1"]=[\2,\3,\4,\7]

ims["vue_rasante.jpg"]=load_image("vue_rasante.jpg")
ims["teapot.jpg"]=load_image("teapot.jpg")
ims["snapshotRelief.png"]=load_image("snapshotRelief.png")

ims["bonzai2.png"]=load_image("bonzai2.png")
ims["hair2.png"]=load_image("hair2.png")
ims["hair.jpg"]=load_image("hair.jpg")
ims["bonzai1.png"]=load_image("bonzai1.png")
ims["slithy.jpg"]=load_image("slithy.jpg")

#xfig_mod=XfigFrame(Rect(0,0,1200,1000))
#xfig_mod.listBox["bonzai2"]=[158,60,367,227]
#xfig_mod.listBox["hair2"]=[397,49,698,233]
#xfig_mod.listBox["hair"]=[464,226,606,333]
#xfig_mod.listBox["bonzai1"]=[196,237,319,330]
#xfig_mod.listBox["slithy"]=[747,76,1081,281]



stencilImg=[load_image("stencil1.png"), load_image("stencil2.png"), load_image("stencil3.png")]





def createurEtSapin(screen_box,c,alpha=1):
	dic={}
	dic["sapin"]=screen_box.move_right(2.7-c).move_up(c)
	dic["createur"]=screen_box.move_right(0.5).move_down(0.5)
	dic["ecran"]=screen_box
	box_image(dic["ecran"],ims["ecran"],alpha)
	box_image(dic["sapin"],ims["sapin1"],alpha)
	box_image(dic["createur"],ims["createur"],alpha)
	
	color(black,alpha)
	size=dic["sapin"].width()*0.5
	begin=get_middle(dic["createur"])
	begin.x=begin.x+dic["createur"].width()*(0.5-0.15*c)
	begin.y=begin.y+dic["createur"].height()*(0.5+0.05*c)
	end=get_middle(dic["sapin"])
	tmpc=0.35
	circle(size/6.0,begin.x,begin.y)
	circle(size/3.0,begin.x*(1-tmpc)+end.x*tmpc,begin.y*(1-tmpc)+end.y*tmpc)
	circle(size,end.x,end.y)
	return dic


def arcProcess(center,radius,avan,w,alpha=1):
	col=[coldic.classe,coldic.inst]
	initAngle=340
	step=[160,280]
	lastAngle=340-avan*step[1]
	if lastAngle<step[0]:
		arcshape1=Path()
		arcshape1.arcn(center.x,center.y,initAngle, initAngle-avan*step[1],radius)
		color(col[0],alpha)
		widestroke(arcshape1,w)
		arcshape2=Path()
		arcshape2.arcn(center.x,center.y,initAngle-step[0], initAngle-avan*step[1],radius)
		color(col[1],alpha)
		widestroke(arcshape2,w)
		arrow(arcshape2,(0,radius*0.2,radius*0.2))
		
		p=Vec2(-1,0)
		color(black,alpha)
		thickness(w*0.5)
		Vec2.line(center+p*radius*1.1,center+p*radius*0.9)
	
	else:
		arcshape=Path()
		arcshape.arcn(center.x,center.y,initAngle, initAngle-avan*step[1],radius)
		color(col[0],alpha)
		widestroke(arcshape,w)
	

draw_processus_color=[ coldic.classe, coldic.inst, black ]
def draw_processus(box,w,arc,alpha,useColor=True):
	thickness(w*0.4)
	createurEtSapin(box,1,alpha)
	center=get_middle(box)
	rayon=box.width()*1.5
	pos_curve=Vec2(center.x-rayon*1,center.y-rayon*0.3)
	color(black,alpha)
	initAngle=340
	angleArray=[0,110,270]
	colorArray=[ coldic.classe, coldic.inst, black ]
	arcProcess(pos_curve,rayon,arc,w,alpha)
				
	def f(x):return initAngle-x
	dic={}
	dic["color"]=colorArray
	dic["angle"]=map(f, angleArray)
	dic["center"]=pos_curve
	dic["rayon"]=rayon
	dic["begin"]=340
	dic["end"]=340-arc*280
	return dic


pasokColor=Color(1,0.2,0.2)
okColor=Color(0.2,0.2,1)
def PrecisionBar(canva,x,y,alpha):
	fontSize=canva.height()*0.6
	bon=blue
	mauvais=black
	trop_petit=canva.left(x)
	trop_gros=canva.right(1-y)
	ok=canva.move_right(x).left(y-x)
	color(pasokColor,alpha)
	rectangle(trop_petit)
	color(pasokColor,alpha)
	rectangle(trop_gros)
	color(okColor,alpha)
	rectangle(ok)
	color(black,alpha)
	p=get_middle(trop_petit)
	text(canva[0]+fontSize*0.3,p.y,"Trop dtaill",timefont,size=fontSize, anchor='cw')
	p=get_middle(trop_gros)
	text(canva[0]+canva.width()-fontSize*0.3,p.y,"Pas assez",timefont,size=fontSize, anchor='ce')
	
	dic={}
	dic["petit"]=trop_petit
	dic["gros"]=trop_gros
	dic["ok"]=ok
	return dic




def drawTrees(img_box,alpha,simp):
	img_box=img_box.restrict_aspect(1.0)
	color(purple,alpha)
	if simp:
		beg=Vec2(img_box[0]+img_box.width(), img_box[1]+img_box.height()*0.5)
		end=Vec2(img_box[0]+img_box.width()*1.2*3, img_box[1]+img_box.height()*0.5)
		frame(img_box)
	else:
		beg=Vec2(img_box.move_right(1.2*2)[0], img_box[1]+img_box.height()*0.5)
		end=Vec2(img_box.move_right(1.2*2)[0]-img_box.width()*1.2*2, img_box[1]+img_box.height()*0.5)
		frame(img_box.move_right(1.2*2))

	arrowimg=Path()
	arrowimg.moveto(beg.x,beg.y)
	arrowimg.lineto(end.x,end.y)
	widestroke(arrowimg,img_box.height()*0.1)
	arrow(arrowimg,(0,img_box.height()*0.3,img_box.height()*0.3))
	box_image(img_box.move_right(1.2*0),ims["arbre0"],alpha)
	box_image(img_box.move_right(1.2*1),ims["arbre1"],alpha)
	box_image(img_box.move_right(1.2*2),ims["arbre2"],alpha)


def draw_arrow_2lines(p1,p2,w1,w2):
	arrowpath=Path()
	arrowpath.moveto(p1.x, p1.y)
	arrowpath.lineto(p2.x, p1.y)
	arrowpath.lineto(p2.x, p2.y)
	widestroke(arrowpath,w1)
	arrow(arrowpath,(0,w2,w2))






class PrecisionContinue:
	def __init__(self,i):
		self.i=i
	def __call__(self,b,o):
		return self.i>1
	def nextStep(self):
		return PrecisionContinue(self.i-1)
	def precision(self):
		return clamp(self.i)

class PrecisionEntiere:
	def __init__(self,i):
		self.i=i
	def __call__(self,b,o):
		return self.i>1
	def nextStep(self):
		return PrecisionEntiere(self.i-1)
	def precision(self):
		if self.i<0.5:
			return 0
		else:
			return 1

class Observateur:
	def __init__(self):
		self.angle=4
		self.middle=Vec2(0,0)
		self.pos=Vec2(0,0)
obs=Observateur()

class PrecisionAdapEntier:
	def __init__(self,i):
		self.i=i
		self.a=i
		self.p=i
	def __call__(self,b,o):
		v=Vec2(b[0]-o.middle.x,b[1]-o.middle.y)
		a=v.angle()
		da=a-o.angle
		if da>3.14:
			da=da-6.28
		if da<-3.14:
			da=da+6.28
		self.a=abs(da)/3.14
		if self.a>1:
			self.a=1
		if self.a*3<self.i:
			return True
		else:
			self.p=1-clamp(self.a*3-self.i)
			return False
		return self.a>self.i
	def nextStep(self):
		return PrecisionAdapEntier(self.i-1)
	def precision(self):
		if self.p<0.5:
			return 0
		else:
			return 1

class PrecisionAdap:
	def __init__(self,i):
		self.i=i
		self.a=i
		self.p=i
	def __call__(self,b,o):
		v=Vec2(b[0]-o.middle.x,b[1]-o.middle.y)
		a=v.angle()
		da=a-o.angle
		if da>3.14:
			da=da-6.28
		if da<-3.14:
			da=da+6.28
		self.a=abs(da)/3.14
		if self.a>1:
			self.a=1
		if self.a*3<self.i:
			return True
		else:
			self.p=1-clamp(self.a*3-self.i)
			return False
		return self.a>self.i
	def nextStep(self):
		return PrecisionAdap(self.i-1)
	def precision(self):
		return self.p


def draw_snow_base(p,w):
	draw_snow_aux_path=Path()
	draw_snow_aux_path.moveto(0,0)
	draw_snow_aux_path.lineto(1,0)
	draw_snow_aux_path.lineto(1.5,1*p)
	draw_snow_aux_path.lineto(2,0)
	draw_snow_aux_path.lineto(3,0)
	widestroke(draw_snow_aux_path,w)

def draw_snow_aux(b,w,f):
	if f(b,obs):
		first_box=Rect(b[0],b[1],b.width()/3,b[3],b.aspect())
		draw_snow_aux(first_box,w,f.nextStep())
		box=first_box.move_right(1.0)
		box=Rect(box[0],box[1],box[2],box[3]+60,box[4])
		draw_snow_aux(box,w,f.nextStep())
		box=box.move_right(1.0)
		box=Rect(box[0],box[1],box[2],box[3]-120,box[4])
		draw_snow_aux(box,w,f.nextStep())
		draw_snow_aux(first_box.move_right(2.0),w,f.nextStep())
	else:
		push()
		thickness(w/b.width())
		translate(b[0],b[1])
		rotate(b[3])
		scale(b.width()/3,b.height())
		draw_snow_base(f.precision(),w/b.width())
		pop()

def draw_snow(b,w,f):
	p=get_middle(b)
	r=b.width()
	
	rad=3.141592/3
	for i in range(0,6):
		a=Vec2(r*cos(i*rad),r*sin(i*rad))
		box=Rect(p.x+a.x,p.y+a.y,r,60*i-120,1).bottom(sqrt(0.75)/3)
		draw_snow_aux(box,w,f)


def draw_fractal_main(fractalBox,w,mode,precision,distance,rotation,alpha=1):
	p=get_middle(fractalBox)
	r=max(0.1,distance)*fractalBox.width()
	fonc = PrecisionEntiere(precision)
	if mode==0:
		fonc = PrecisionEntiere(precision)
	elif mode==1:
		fonc = PrecisionContinue(precision)
	elif mode==2:
		fonc = PrecisionAdapEntier(3)
	elif mode==3:
		fonc = PrecisionAdap(3)

	obs.middle=p
	obs.angle=rotation*6.28-3.14
	dec=-obs.angle
	obs.pos=Vec2(p.x+r*cos(dec),p.y+r*sin(dec))
	if distance>0.0:
		color(red,alpha)
		dot(w,obs.pos.x,obs.pos.y)
	color(black,alpha)
	draw_snow(fractalBox,w*1.5,fonc)


class GraphTrue:
	mainbox=Rect(0,0,width=1,height=1)
	th=0
	def __init__(self,mainbox,th):
		self.mainbox=mainbox
		self.th=th
	def __call__(self,b):
		return True
	def width(self,b):
		p=get_middle(b)
		return self.th*sqrt((p.y-self.mainbox[1])/self.mainbox.height())

class GraphLine(GraphTrue):
	def __init__(self,mainbox,a,th):
		GraphTrue.__init__(self,mainbox,th)
		self.p=get_middle(mainbox.move_down(0.2))
		self.a=a
	def __call__(self,b):
		p=get_middle(b)
		y=(p.x-self.p.x)*self.a+self.p.y
		return y<p.y


graphColor={}
graphColor["normal"]=coldic.inst
graphColor["leave"]=coldic.inst
graphColor["line"]=black
graphColor["alpha"]=1

class Graph:
	def __init__(self,maxcount=-1):
		self.count=0
		self.maxcount=maxcount
		self.lastp=Vec2(0,0)
		self.lastbox=None
		self.leaveSpecialColor=None
	def goon(self):
		return self.maxcount==-1 or self.count<self.maxcount
	def draw_graph(self,box,ml,f):
		self.count=self.count+1
		if self.goon():
			maxLevel=int(ml)
			h=box.height()
			w=box.width()
			if maxLevel>0 and f(box):
				coef=float(maxLevel)/(maxLevel+1)
				bot=box.bottom(coef)
				top=box.top(1-coef)
				p=get_middle(top)
				b1=bot.left(0.5)
				b2=bot.right(0.5)
				p1=Vec2(p.x-top.width()*0.25,p.y-top.height())
				p2=Vec2(p.x+top.width()*0.25,p.y-top.height())
				color(graphColor["line"],graphColor["alpha"])
				Vec2.line(p,p1)
				Vec2.line(p,p2)
				test1=self.draw_graph(b1,ml-1,f)
				test2=self.draw_graph(b2,ml-1,f)
				self.lastp=p
				self.lastbox=top
				if test1:
					color(graphColor["normal"],graphColor["alpha"])
				else:
					color(graphColor["leave"],graphColor["alpha"])
				dot(f.width(b1),p1.x,p1.y)
				if test2:
					color(graphColor["normal"],graphColor["alpha"])
				else:
					color(graphColor["leave"],graphColor["alpha"])
				dot(f.width(b2),p2.x,p2.y)
				return True
			else:
				return False
		else:
			return True

def draw_graph_main(mode,box,ml,w,completion,rotation,alpha):
	graphColor["alpha"]=alpha
	f=GraphTrue(box,w)
	if mode==1:
		f=GraphLine(box,rotation,w)
	g=Graph(int(completion*pow(2,(int(ml)+1))))
	g.draw_graph(box,ml,f)
	if g.lastbox!=None:
		color(graphColor["normal"],graphColor["alpha"])
		dot(f.width(g.lastbox),g.lastp.x,g.lastp.y)
	
	color(graphColor["normal"],alpha)
	b2=box.top(1.0/(ml+1))
	p2=get_middle(b2)
	dot(f.width(b2),p2.x,p2.y)
	
	dic={}
	dic["firstbox"]=g.lastbox
	dic["firstPoint"]=p2
	dic["root"]=g.lastp
	return dic

def draw_antibox(box,c,f=False):
	canva=Rect(visible())
	color(c)
	if f:
		frame(canva[0],canva[1],canva[0]+canva.width(),box[1])
		frame(canva[0],box[1]+box.height(),canva[0]+canva.width(), canva[1]+canva.height())
		frame(canva[0],box[1],box[0],box[1]+box.height())
		frame(box[0]+box.width(),box[1],canva[0]+canva.width(), box[1]+box.height())
	else:
		rectangle(canva[0],canva[1],canva[0]+canva.width(),box[1])
		rectangle(canva[0],box[1]+box.height(),canva[0]+canva.width(), canva[1]+canva.height())
		rectangle(canva[0],box[1],box[0],box[1]+box.height())
		rectangle(box[0]+box.width(),box[1],canva[0]+canva.width(), box[1]+box.height())

def draw_clock(p,size,time,alpha=1):
	pi=3.141592
	angle=pi/2-2*pi*time
	color(black,alpha)
	dot(size*0.1,p.x,p.y)
	pp=Vec2(cos(angle),sin(angle))*(size*0.9)
	circle(size,p.x,p.y)
	nb=12
	for i in range(0,nb):
		c=2*3.1415/nb
		p1=Vec2(cos(i*c),sin(i*c))*(size*0.8)
		p2=Vec2(cos(i*c),sin(i*c))*(size*1.0)
		Vec2.line(p+p1,p+p2)
	color(purple,alpha)
	Vec2.line(p,p+pp)

class Zbuffer_precision:
	def __init__(self,box):
		self.box=box
		self.hmax=box.height()*0.5
		self.origin=box.width()*0.2
		self.fontSize=self.hmax*0.1
		self.reduc=2.0
		self.middley=box[1]+self.box.height()*0.5
		self.pointArray=[]
		self.dec=self.box.width()*0.05

		current=self.box.width()*0.002
		while current<self.box.width():
			self.pointArray.append(current+self.dec)
			current=current*self.reduc
		self.nbZone=len(self.pointArray)
		
		self.colorArray=[]
		for i in range(0,self.nbZone-1):
			self.colorArray.append(Color(0.2+i*0.8/self.nbZone,0.3,0.0))

	def f(self,x):
		coef=self.hmax/(self.box.width()+self.origin)
		return (x+self.origin)*coef

	def draw(self,linear,fill,alpha=1):
		
		inclinear=(self.box.width()-self.dec)/self.nbZone
		for i in range(0,self.nbZone):
			self.pointArray[i]=(1-linear)*self.pointArray[i]+linear*(self.dec+inclinear*i)
		
		maxi=min(int(fill*(self.nbZone-1)),self.nbZone-1)
		for i in range(0,maxi):
			h1=self.f(self.pointArray[i])
			h2=self.f(self.pointArray[i+1])
			color(self.colorArray[i],alpha)
			polygon(self.box[0]+self.pointArray[i], self.middley+h1, self.box[0]+self.pointArray[i], self.middley-h1, self.box[0]+self.pointArray[i+1], self.middley-h2, self.box[0]+self.pointArray[i+1], self.middley+h2)
			p1=Vec2(self.box[0],self.box[1]+self.box.height()*0.5)
		
		color(black,alpha)
		for i in range(0,self.nbZone):
			h=self.f(self.pointArray[i])
			line(self.box[0]+self.pointArray[i], self.middley+h, self.box[0]+self.pointArray[i], self.middley-h)
			text(self.box[0]+self.pointArray[i], self.middley+h+0.1*self.hmax, "10e"+str((i-self.nbZone/2)*8), timefont, size=self.fontSize)

		color(black,alpha)
		h1=self.f(0)
		p1=Vec2(self.box[0],self.box[1]+self.box.height()*0.5)
		h2=self.f(self.box.width())
		p2=Vec2(self.box[0]+self.box.width(),self.box[1]+self.box.height()*0.5)
		line(p1.x,p1.y+h1,p2.x,p2.y+h2)
		line(p1.x,p1.y-h1,p2.x,p2.y-h2)
		
		oeilSize=self.box.width()*0.2
		self.box=Rect(self.box[0]-self.origin,self.box[1]+self.box.height()*0.5, width=oeilSize, height=oeilSize)
		box_image(self.box,ims["oeil"],alpha)



def title(canva,titleStr,alpha=1):
	color(coldic.font,alpha)
	box=titleBox(canva)
	middle=get_middle(box)
	text(middle.x,middle.y,titleStr, timefont, size=canva.height()*titleSize, justify=0.5)
	return box

def txt_frame(res,bigger=0,rectOrFrame=True):
	w=res["width"]
	h=res["height"]
	c=0.1
	p=Vec2(res["left"],res["bottom"])
	r=Rect(p.x-w*c,p.y-h*c, p.x+w*(1+c), p.y+h*(1+c)).outset(bigger)
	if rectOrFrame:
		rectangle(r)
	else:
		frame(r)


