# -*- coding: <utf-8> -*-

import getopt,sys

localOpt={}
def getLocalOpt():
	index=-1
	for i in range(1,len(sys.argv)):
		if sys.argv[i]=="-i":
			if i<(len(sys.argv)-1):
				index=i
				try:
					localOpt["play"]=int(sys.argv[i+1])
					sys.argv=sys.argv[0:i]+sys.argv[i+2:len(sys.argv)]
					break
				except:
					raise TypeError, "bad value for -index"
getLocalOpt()

from slithy.presentation import *

from common import *
from main import *
from biblio import *
from prairie import *
from dg import *
from resultat import *

bg=Fill(style='horz',color=white,color2=white)

def firstPart():
	p1=Drawable(get_camera(),FirstPage)
	p2=Drawable(get_camera(),SecondPage)
	p3=Drawable(get_camera(),ThirdPage)
	p4=Drawable(get_camera(),FourPage)
	p5=Drawable(get_camera(),Aliasing)
	p6=Drawable(get_camera(),AntiAliasing)
	p7=Drawable(get_camera(),Simplification)
	p8=Drawable(get_camera(),Complexification)
	p9=Drawable(get_camera(),EtatArt)
	p10=Drawable(get_camera(),ArtBilan)
	ddd=Drawable(get_camera(),DDD)
	
	#intro
	def Anim_start():
		enter(p1)
		pause() #intro
		smooth(0.25,p1.presentation,0.0)
#		smooth(0.25,p1.motivation,1.0)
#		pause()
		smooth(1,p1.motivation,2.0)
		pause()
		smooth(0.25,p1.motivation,0.0)
		smooth(0.25,p1.application,1.0)
		pause()
		smooth(0.25,p1.application1,1.0)
		pause()
		smooth(0.25,p1.application1,0.0)
		smooth(0.25,p1.application2,1.0)
		pause()
		smooth(0.25,p1._alpha,0.0)
		exit(p1)
	
	def Anim_ddd1():
		enter(ddd)
		set(ddd._alpha,0.0)
		smooth(0.25,ddd._alpha,1.0)
		pause()
		smooth(0.25,ddd.initarrow,1.0)
		pause()
		smooth(0.5,ddd.choice,0.0)
		exit(ddd)
	
	#intro
	def Anim_over():
		over=Drawable(get_camera(),Slide_over)
		enter(over)
		pause()
		exit(over)
	
	#5sens
	def Anim_sense():
		enter(p2)
		set(p2._alpha,0)
		smooth(0.4,p2._alpha,1.0)
		pause() # page 5 sens
		smooth(0.2,p2.sense,0.0)
		pause() # sens:toucher
		smooth(0.2,p2.sense,1.5)
		pause() # sens:odorat+gout
		smooth(0.2,p2.sense,3.0)
		pause() # sens:ouie
		smooth(0.2,p2.slide1,1.0)
		smooth(0.2,p2.sound,1.0)
		pause() # sens:ouie
		smooth(0.2,p2.slide2,1.0)
		smooth(0.2,p2.sound,2.0)
		pause() # sens:ouie
		smooth(0.2,p2.slide2,2.0)
		smooth(0.2,p2.sound,3.0)
		pause() # sens:ouie
		parallel()
		smooth(0.2,p2.slide1,0.0)
		smooth(0.2,p2.sound,0.0)
		smooth(0.2,p2.slide2,0.0)
		end()
		pause() # sens:ouie
		smooth(1.0,p2.zoom,1.0)
		exit(p2)
	
	#multi-echelle
	def Anim_multi():
		enter(p3)
		smooth(0.5,p3.alphaTitre,4.0)
		pause() # de pres
		linear(0.5,p3.deloin,1.0)
		pause() # de loin
		smooth(0.5,p3.info,1.0)
		pause() # de loin
		smooth(0.5,p3.info,2.0)
		pause() # en informatique
		smooth(0.5,p3.info,3.0)
		wait(0.2) # en informatique
		smooth(0.5,p3.info,4.0)
		smooth(0.5,p3.info,5.0)
		exit(p3)
		enter(p4)
		set(p4.alphaTitre,1.0)
		smooth(0.5,p4.zoom,1.0)
		smooth(0.7,p4.arc,1.0)
		pause()
		smooth(0.25,p4.adaptatif2,1.0)
		pause()
		smooth(0.25,p4.adaptatif,1.0)
		pause()
		set(p4.adaptatif,0.0)
		set(p4.adaptatif2,0.0)
		exit(p4)
	
	#processus de creation
	def Anim_processus():
		enter(p4)
#		linear(0.2,p4.alphaTitre,1.0)
#		linear(0.5,p4.zoom,1.0)
		set(p4.zoom,1.0)
		set(p4.arc,1.0)
		parallel()
		smooth(0.25,p4.alphaTitre,1.0)
		smooth(0.25,p4.pb,1.0)
		end()
		pause()
		parallel()
		linear(0.5,p4.pb,2.0)
		linear(0.5,p4.alphacircle,1.0)
		end()
		pause()
		enter(p5)
		parallel()
		smooth(1.0,p4.echantillon,1.0)
		linear(0.5,p5.build,1.0)
		end()
		exit(p4)
		exit(p5)
	
	#aliasing
	def Anim_aliasing():
		enter(p5)
		set(p5.build,1.0)
		set(p5.setCam,True)
		linear(0.2,p5.alphaecran,1.0)
		linear(0.2,p5.poly,1.0)
		pause()
		linear(0.25,p5.showarrow,1.0)
		parallel()
		linear(0.5,p5.big,0.0)
		linear(0.5,p5.arrow,1.0)
		end()
		smooth(0.25,p5.sur,1.0)
		pause()
		smooth(0.25,p5.sur,0.0)
		parallel()
		linear(0.5,p5.big,1.0)
		linear(0.5,p5.arrow,0.0)
		end()
		smooth(0.25,p5.sous,1.0)
		pause()
		smooth(0.25,p5.sous,0.0)
		parallel()
		linear(0.5,p5.big,0.05)
		linear(0.5,p5.arrow,0.5)
		smooth(0.25,p5.ok,1.0)
		end()
		pause()
		enter(p4)
		set(p5.setCam,False)
		parallel()
		smooth(0.2,p5.alphaecran,0.0)
		smooth(0.5,p5._alpha,0.0)
		smooth(1.0,p4.echantillon,0.0)
		end()
		exit(p5)
		exit(p4)
	
	#solution?
	def Anim_solution():
		enter(p4)
		pause()
		linear(0.5,p4.pb,3.0)
		linear(0.5,p4.solution,1.0)
		pause()
		linear(0.5,p4.angle,angleValue[1])
		pause()
		enter(p6)
		parallel()
		smooth(1.0,p4.antialiasing,1.0)
		smooth(0.5,p6.build,1.0)
		end()
		exit(p4)
	
	#antialiasing
	def Anim_antiAliasing():
		enter(p6)
		set(p6.setCam,True)
		pause()
		linear(0.5,p6.build,2.0)
		wait(0.2)
		linear(0.5,p6.build,3.0)
		pause()
		linear(0.5,p6.build,4.0)
		wait(0.2)
		linear(0.5,p6.build,5.0)
		pause()
		linear(0.5,p6.build,6.0)
		pause()
		linear(0.5,p6.build,7.0)
		pause()
		set(p6.setCam,False)
		enter(p4)
		parallel()
		smooth(0.5,p6._alpha,0.0)
		smooth(1.0,p4.antialiasing,0.0)
		end()
		exit(p6)
		exit(p4)
	
	# goto simplification
	def Anim_solution2():
		enter(p4)
		pause()
		linear(0.5,p4.angle,angleValue[2])
		enter(p7)
		pause()
		parallel()
		smooth(1.0,p4.simplification,1.0)
		linear(0.5,p7.build,1.0)
		end()
		exit(p4)
	
	#simplification
	def Anim_simplification():
		enter(p7)
		set(p7.build,1.0)
		set(p7.setCam,True)
		pause()
		linear(0.5,p7.textdebut,1.0)
		pause()
#		linear(0.5,p7.textdebut,2.0)
#		pause()
#		linear(0.5,p7.textdebut,3.0)
#		pause()
		parallel()
		set(p7.textdebut,3.5)
		linear(0.5,p7.textdebut,4.0)
		linear(0.5,p7.smallTree,1.0)
		serial()
		linear(0.25,p7.precision,0.0)
		linear(0.25,p7.precision,1.0)
		end()
		end()
		pause()
		parallel()
		linear(0.5,p7.move,1.0)
		linear(0.5,p7.bar,1.0)
		linear(0.5,p7.comment,1.0)
		end()
		pause()
		parallel()
		linear(0.3,p7.move,1.5)
		end()
		parallel()
		linear(0.3,p7.limitesimp,1)
		linear(0.3,p7.cross,1)
		end()
		pause()
		parallel()
		linear(0.3,p7.limitesimp,1.5)
		linear(0.3,p7.cross,0)
		end()
		linear(0.5,p7.move,-0.5)
		parallel()
		linear(0.3,p7.cross,1)
		linear(0.3,p7.limitesimp,2)
		end()
		pause()
		linear(0.3,p7.comment,2.0)
		pause()
		set(p7.setCam,False)
		enter(p4)
		parallel()
		smooth(0.5,p7._alpha,0.0)
		smooth(1.0,p4.simplification,0.0)
		end()
		exit(p7)
		pause()
		exit(p4)
	
	# goto complexification
	def Anim_solution3():
		enter(p4)
		linear(0.5,p4.angle,angleValue[3])
		pause()
		enter(p8)
		parallel()
		smooth(1.0,p4.complexification,1.0)
		smooth(0.5,p8.build,1.0)
		end()
		set(p8.setCam,True)
		exit(p4)
		pause()
	
	def Anim_complexification1():
		enter(p8)
		set(p8.build,1.0)
		set(p8.setCam,True)
		linear(0.5,p8.zoom,1.0)
		linear(0.5,p8.bar,0.0)
		pause()
		parallel()
		linear(0.5,p8.move,1.0)
		linear(0.5,p8.bar,1.0)
		end()
		pause()
		linear(0.5,p8.move,1.5)
		linear(0.25,p8.limitdown,1.0)
		wait(0.5)
		linear(0.25,p8.limitdown,2.0)
		pause()
		linear(0.25,p8.limitdown,0.0)
		linear(0.5,p8.move,-0.5)
		linear(0.5,p8.limitup,1.0)
		wait(0.5)
		linear(0.5,p8.limitup,2.0)
		pause()
		linear(0.5,p8.comment,1.0)
		pause()
		linear(0.5,p8.comment,2.0)
		pause()
#		linear(0.5,p8.slide,1.0)
		smooth(0.25,p8.hide,0.0)
		exit(p8)
	
	def Anim_complexification2():
		enter(p9)
		set(p9.setCam,True)
#		smooth(0.5,p9.des,1.0)
#		pause()
#		smooth(0.25,p9.showTab,1.0)
#		pause()
#		smooth(0.25,p9.showTab,2.0)
#		pause()
#		smooth(0.25,p9.showTab,3.0)
#		pause()
#		smooth(0.25,p9.showTab,4.0)
#		pause()
#		smooth(0.5,p9.showdes,1.0)
#		pause()
#		smooth(0.5,p9.x1,1.0)
#		pause()
#		smooth(0.5,p9.x2,1.0)
#		pause()
#		smooth(0.5,p9.showArrow,1.0)
#		smooth(0.5,p9.x2,0.7)
#		pause()
#		smooth(0.5,p9.des,0.0)
#		smooth(1.0,p9.multi,1.0)
		smooth(0.5,p9.build,2.0)
		pause()
		parallel()
		smooth(0.5,p9.cam,1.0)
		smooth(0.5,p9.fractale,1.0)
		smooth(0.5,p9.carac,1.0)
		end()
		pause()
		smooth(0.5,p9.lsystem,1.0)
		pause()
		smooth(0.5,p9.lsystem,2.0)
		pause()
		
		parallel()
		smooth(0.25,p9.lsystem,3.0)
		smooth(0.25,p9.cpfg,0.0)
		smooth(0.25,p9.carac,0.0)
		end()
		smooth(0.5,p9.tii,1.0)
		smooth(0.25,p9.platonic,1.0)
		pause()
		smooth(0.25,p9.platonic,2.0)
		pause()
		smooth(0.25,p9.platonic,3.0)
#		pause()
#		smooth(0.25,p9.platonic,4.0)
		
		pause()
		parallel()
		smooth(0.25,p9.platonic,0.0)
		smooth(0.25,p9.tii,0.0)
		smooth(0.5,p9.fractale,0.0)
		smooth(0.5,p9.cam,2.0)
		end()
		pause()
		parallel()
		smooth(0.5,p9.cam,3.0)
		smooth(0.5,p9.particulier,1.0)
		end()
		pause()
		smooth(0.5,p9.picture,1.0)
		smooth(0.5,p9.particulier_t,1.0)
		pause()
		linear(0.5,p9.case,2.9999)
		pause()
		linear(0.3,p9.case,3.9999)
		linear(0.3,p9.case,4.9999)
		pause()
		linear(0.6,p9.case,8.9999)
		pause()
		smooth(0.25,p9.dg,1.0)
		smooth(0.25,p9.dg,2.0)
		pause()
		linear(0.5,p9.commun,1.0)
		pause()
		linear(0.5,p9.commun,2.0)
		pause()
		parallel()
		smooth(0.5,p9.particulier,0.0)
		smooth(0.5,p9.cam,4.0)
		end()
		pause()
		parallel()
		smooth(0.5,p9.cam,5.0)
		smooth(0.5,p9.api,1.0)
		end()
		pause()
		smooth(0.5,p9.processus0,1.0)
		pause()
		smooth(0.5,p9.processus0,0.0)
		smooth(0.5,p9.processus,1.0)
		pause()
		smooth(0.5,p9.processus,2.0)
		pause()
		parallel()
		smooth(0.5,p9.api,0.0)
		smooth(0.5,p9.cam,6.0)
		end()
		pause()
		
		enter(p4)
		set(p9.setCam,False)
		parallel()
		smooth(1.0,p4.complexification,0.0)
		smooth(0.5,p9.build,1.0)
		smooth(0.5,p9._alpha,0.0)
		end()
		exit(p9)
		pause()
		smooth(0.25,p4._alpha,0.0)
		exit(p4)
		enter(p10)
		smooth(0.25,p10.alphaTitle,1.0)
		set(p10.txt,3.0)
		pause()
		smooth(0.25,p10.showTxt,1.0)
		pause()
		smooth(0.25,p10.txt,4.0)
		pause()
		parallel()
		smooth(0.25,p10.alphaTitle,0.0)
		smooth(0.25,p10.showTxt,0.0)
		end()
		exit(p10)
		
		
	
	def Anim():
		Anim_start()
		Anim_multi()
		Anim_ddd1()
		Anim_processus()
		Anim_aliasing()
		Anim_solution()
		Anim_antiAliasing()
		Anim_solution2()
		Anim_simplification()
		Anim_solution3()
		Anim_complexification1()
		Anim_complexification2()
	
	Anim()




def prairiePart():
	ddd=Drawable(get_camera(),DDD)
	p1=Drawable(get_camera(),prairie)
	
	enter(ddd)
	set(ddd.choice,0.0)
	set(ddd.arrow,0.0)
	set(ddd.initarrow,1.0)
	smooth(0.5,ddd.choice,0.5)
	pause()
	smooth(0.5,ddd.arrow,1.0)
	pause()
	smooth(0.5,ddd.choice,1.0)
	exit(ddd)
	
	enter(p1)
	smooth(0.5,p1.build,1)
	set(p1.showTxtIntro,1)
	pause()
	smooth(0.5,p1.txtIntro,1)
	pause()
	smooth(0.5,p1.txtIntro,2)
	pause()
	smooth(0.5,p1.txtIntro,3)
	pause()
	smooth(0.5,p1.showTxtIntro,0)
	linear(0.5,p1.title,1)
	parallel()
	smooth(0.5,p1.ter,1)
	smooth(0.5,p1.showLod,1)
	end()
	pause()
	smooth(1,p1.camrot,1)
	smooth(1,p1.camPos,1)
	pause()
	smooth(1,p1.camPos,0)
	smooth(0.5,p1.showLodArrow,1)
	smooth(5,p1.camPos,1)
	pause()
	smooth(0.5,p1.ter,0)
	smooth(0.5,p1.showSquare,1)
	pause()
	smooth(4,p1.lod,1)
	pause()
	smooth(0.25,p1.showTex,1)
	pause()
	smooth(0.25,p1.showTex,0)
	pause()
	smooth(4,p1.lod,2)
	pause()
	linear(0.5,p1.title,2)
	parallel()
	smooth(0.5,p1.showSquare,0)
	smooth(0.5,p1.showLod,0)
	end()
	
	parallel()
	smooth(0.5,p1.anim_3d,1)
	smooth(0.5,p1.showGraph,1)
	end()
	pause()
	smooth(5,p1.mov1,1)
	pause()
	set(p1.mov1,0)
	smooth(0.5,p1.anim_2_5d,1)
	pause()
	smooth(1.5,p1.anim_2_5d2,2)
	pause()
	smooth(5,p1.mov2,1)
	pause()
	smooth(0.5,p1.anim_2d,1)
	pause()
	smooth(0.5,p1.showGraph,0)
	smooth(0.5,p1.primitive,1)
	pause()
	smooth(0.5,p1.primitive2,1)
	pause()
	smooth(1.5,p1.move_prim,1)
	pause()
	parallel()
	smooth(0.5,p1.primitive,0)
	smooth(0.5,p1.primitive2,0)
	smooth(0.5,p1.anim_2d,0)
	smooth(0.5,p1.anim_3d,0)
	smooth(0.5,p1.anim_2_5d,0)
	end()
	
	linear(0.5,p1.title,3)
	smooth(0.5,p1.showres,1)
	pause()
	smooth(0.5,p1.showres,0)
	linear(0.5,p1.title,4)
	set(p1.showTxtConclu,1)
	smooth(0.5,p1.txtConclu,1)
	pause()
	smooth(0.5,p1.txtConclu,2)
	pause()
	smooth(0.5,p1.txtConclu,3)
	pause()
	smooth(0.5,p1.txtConclu,4)
	pause()
	
	parallel()
	smooth(0.5,p1.showTxtConclu,0)
	smooth(0.5,p1.build,0)
	end()
	exit(p1)


def secondPart():
	ddd=Drawable(get_camera(),DDD)
	p1=Drawable(get_camera(),dgFirst)
	p2=Drawable(get_camera(),dgDecomposition)
	p3=Drawable(get_camera(),dgModelisation)
	p4=Drawable(get_camera(),dgEvaluation)
	p5=Drawable(get_camera(),dgPrecision)
	p6=Drawable(get_camera(),dgMemoire)
	p7=Drawable(get_camera(),dgAnimation)
	p8=Drawable(get_camera(),dgRendu)
	p9=Drawable(get_camera(),dgVisibilite)
	p10=Drawable(get_camera(),dgCritere)
	p11=Drawable(get_camera(),dgVisibilite2)
	p12=Drawable(get_camera(),dgVisibilite0)
	p15=Drawable(get_camera(),bilanArbre)
	
	def Anim_gotoDG():
		enter(ddd)
		set(ddd.choice,1.0)
		set(ddd.initarrow,1.0)
		set(ddd.arrow,1.0)
		smooth(0.5,ddd.choice,1.5)
		pause()
		smooth(0.5,ddd.arrow,2.0)
		pause()
		smooth(0.5,ddd.choice,2.0)
		exit(ddd)

	def Anim_first():
		enter(p1)
		set(p1._alpha,0)
		set(p1.showVueTxt,1.0)
		smooth(0.25,p1._alpha,1.0)
		pause()
		smooth(0.25,p1.vueTxt,1.0)
		pause()
		smooth(0.25,p1.vueTxt,2.0)
		pause()
		smooth(0.25,p1.vueTxt,3.0)
		pause()
		smooth(0.25,p1.vueTxt,4.0)
		pause()
		smooth(0.25,p1.showVueTxt,0.0)
		smooth(1,p1.ti,2.0)
		pause()
		smooth(0.25,p1.bar,1)
		smooth(0.5,p1.showsegment,1)
		pause()
		linear(1.0,p1.segment,1)
		pause()
#		smooth(0.5,p1.nomansland,1)
		linear(1.5,p1.segment,0.0)
		pause()
		smooth(1.0,p1.snow_f,1)
		smooth(0.25,p1.showfrac,1.0)
		pause()
		linear(1.0,p1.segment,0.7)
		wait(1.5)
		linear(1.0,p1.segment,0.4)
		pause()
		parallel()
		smooth(0.25,p1.showsegment,0)
		smooth(0.25,p1.bar,0)
		end()
		smooth(1.0,p1.snow_f,2)
		smooth(0.5,p1.adaptatif,1)
		smooth(1.0,p1.rotation,1)
		wait(0.5)
		smooth(1.0,p1.rotation,0)
		pause()
		smooth(1.0,p1.snow_f,3)
		set(p1.continu,True)
		smooth(1.0,p1.rotation,1)
		wait(0.5)
		smooth(1.0,p1.rotation,0)
		pause()
		smooth(0.5,p1.tree,1)
		smooth(0.5,p1.tree,2)
		pause()
		set(p1.rotation,1)
		linear(2,p1.graphRot,-1)
		set(p1.rotation,-2)
		linear(2,p1.graphRot,1)
		set(p1.rotation,0)
		pause()
		smooth(0.25,p1._alpha,0)
		exit(p1)
	
	def Anim_decomposition():
		enter(p2)
		set(p2._alpha,0)
		set(p2.processus,1)
		smooth(0.25,p2._alpha,1)
		smooth(0.25,p2.fra,1)
		pause()
		smooth(0.25,p2.zone,1)
		smooth(0.25,p2.avan,1)
		pause()
		smooth(0.25,p2.zone,2)
		
		pause()
		smooth(1.0,p2.modelisation,1)
		enter(p3)
		parallel()
		smooth(0.25,p3.showsnow,1)
		smooth(0.25,p3.build,1)
		end()
		exit(p2)
		exit(p3)
	
	def Anim_modelisation():
		enter(p3)
		set(p3.showsnow,1)
		set(p3.show1,1)
		set(p3.show2,1)
		set(p3.build,1)
		pause()
		smooth(0.25,p3.showsnow,0)
		smooth(0.5,p3.other,1)
		pause()
		smooth(0.5,p3.pointinter,1)
		pause()
		parallel()
		smooth(0.5,p3.quoi,1)
		smooth(0.5,p3.inter,1)
		end()
		pause()
		parallel()
		smooth(0.5,p3.quoi,2)
		smooth(0.5,p3.inter,2)
		end()
		pause()
		parallel()
		smooth(0.25,p3.pointinter,0)
		smooth(0.25,p3.inter,0)
		smooth(0.25,p3.other,0)
		smooth(0.25,p3.showsnow,0)
		end()
		smooth(1.0,p3.tt,2)
		smooth(0.25,p3.classe,1)
		pause()
		smooth(0.25,p3.classe,2)
		pause()
		smooth(0.25,p3.classe,3)
		pause()
		smooth(0.25,p3.classe,4)
		pause()
		smooth(0.25,p3.show1,0)
		smooth(0.25,p3.tt,0)
		smooth(1,p3.tt2,2)
		pause()
		smooth(0.25,p3.showGui,1)
		pause()
		smooth(0.25,p3.showGui,0)
#		smooth(0.25,p3.showGui2,1)
#		pause()
#		smooth(0.25,p3.showGui2,0)
		smooth(0.25,p3.tt2,0)
#		smooth(0.5,p3.slideclasse,1)
#		smooth(0.5,p3.nedit,1)
#		smooth(0.25,p3.quoi,0)
#		smooth(0.5,p3.visu,1)
#		smooth(0.5,p3.showtext,1)
#		pause()
#		smooth(0.5,p3.visu,0)
#		smooth(0.5,p3.showtext,2)
#		pause()
#		smooth(0.5,p3.showtext,3)
#		pause()
#		smooth(0.5,p3.showtext,4)
#		pause()
#		parallel()
#		smooth(0.25,p3.show1,0)
#		smooth(0.25,p3.show2,0)
#		end()
#		set(p3.showtext,0)
#		set(p3.classe,0)
#		smooth(0.25,p3.slide,1)
#		smooth(0.5,p3.uti,1)
		
		smooth(0.5,p3.uti,2)
		pause()
		smooth(0.5,p3.uti,3)
		wait(0.2)
		smooth(0.5,p3.uti,4)
		wait(0.2)
		smooth(0.5,p3.uti,5)
		pause()
		smooth(0.5,p3._alpha,0)
		exit(p3)
	
	
	def Anim_transition():
		enter(p2)
		set(p2._alpha,0)
		set(p2.modelisation,1)
		set(p2.zone,3)
		set(p2.avan,1)
		set(p2.fra,1)
		set(p2.noslide,True)
		parallel()
		smooth(0.25,p2._alpha,1)
		smooth(0.5,p2.modelisation,0)
		end()
		pause()
		smooth(0.5,p2.showRec,1)
		pause()
		parallel()
		smooth(0.5,p2._alpha,0)
		smooth(0.5,p2.evaluation1,1)
		end()
		exit(p2)
	
	def Anim_transition3():
		enter(p2)
		set(p2._alpha,0)
		set(p2.modelisation,0)
		set(p2.zone,3)
		set(p2.avan,1)
		set(p2.fra,1)
		set(p2.noslide,True)
		parallel()
		smooth(0.25,p2._alpha,1)
		smooth(0.5,p2.evaluation1,0)
		end()
		pause()
		smooth(0.5,p2.showRec,2)
		pause()
		parallel()
		smooth(0.5,p2._alpha,0)
		smooth(0.5,p2.evaluation1,1)
		end()
		exit(p2)
	
	def Anim_evaluation():
		enter(p4)
		set(p4._alpha,0)
		set(p4.graph,0.0)
		smooth(0.5,p4._alpha,1)
		smooth(0.5,p4.te,1)
		linear(0.5,p4.showgraph,1)
		pause()
		smooth(0.5,p4.te,2)
		linear(3.0,p4.graph,1)
		pause()
		smooth(0.5,p4.te,3)
		smooth(0.25,p4.crit,1)
		pause()
		smooth(0.5,p4.voit,1)
		pause()
		smooth(0.5,p4._alpha,0)
		exit(p4)
	
	
	def Anim_precision():
		enter(p5)
		set(p5._alpha,0)
		set(p5.oeil,1)
		smooth(0.25,p5._alpha,1)
		smooth(0.5,p5.fonc,1)
#		pause()
#		set(p5.cohe,3)
#		linear(0.5,p5.pre,1)
#		wait(0.5)
#		linear(0.5,p5.pre,0)
		set(p5.cohe,0)
		
		pause()
		linear(2,p5.pre,1)
		pause()
		
		smooth(0.25,p5.drawmat,1)
		pause()
		smooth(0.25,p5.drawPrecision,1)
		pause()
		linear(1,p5.pre,0)
		pause()
		linear(1,p5.pre,1)
		smooth(0.5,p5.treshold,1)
		pause()
		linear(0.5,p5.pre,-0.1)
#		pause()
		smooth(0.5,p5.fonc,2)
		
		pause()
		parallel()
		smooth(0.25,p5.drawmat,0)
		smooth(0.5,p5.fonc,0)
		end()
		smooth(0.5,p5.graph,1)
		smooth(1,p5.pre,1)
		wait(0.5)
		smooth(1,p5.pre,0)
		pause()
		parallel()
		smooth(0.5,p5.graph,0)
		smooth(0.5,p5.oeil,0)
		end()
		smooth(0.25,p5.preTxt,1)
		pause()
		smooth(0.25,p5.preTxt,2)
		pause()
		smooth(0.25,p5.preTxt,3)
		pause()
		smooth(0.25,p5.preTxt,4)
		pause()
		
#		set(p5.treshold,0)
#		smooth(0.5,p5.graph,0)
#		smooth(0.5,p5.fonc,1)
#		smooth(0.25,p5.drawmat,1)
#		smooth(0.25,p5.txt1,1)
#		pause()
		
#		linear(0.5,p5.pre,1)
#		pause()
#		linear(0.5,p5.pre,0.5)
#		smooth(0.25,p5.txt2,1)
#		pause()
#		smooth(0.25,p5.txt1,2)
#		pause()
#		set(p5.cohe,1)
#		set(p5.pre,0.0)
#		linear(1.5,p5.pre,1)
#		pause()
#		set(p5.cohe,2)
#		linear(1.5,p5.pre,0)
#		pause()
#		smooth(0.25,p5.txt1,3)
#
#		pause()
#		smooth(0.5,p5.slide,1)
#		smooth(0.25,p5.txt2,0)
		smooth(0.25,p5._alpha,0)
		exit(p5)
	
	class TimeValue:
		def __init__(self):
			self.timeValue=0.0
		def get(self):
			return self.timeValue
		def inc(self,t):
			self.timeValue+=t
			return self.timeValue
	timeValue=TimeValue()
	
	def Anim_memoire():
		tv=TimeValue()
		enter(p6)
		set(p6.colorTitle,1)
		set(p6.tv,tv.get())
		set(p6.rot,1)
		smooth(0.25,p6._alpha,1)
		parallel()
		smooth(0.5,p6.build,1)
		smooth(0.5,p6.title,1)
		smooth(0.5,p6.showcase,1)
		smooth(0.5,p6.showclock,1)
		end()
		pause()
		parallel()
		smooth(0.25,p6.showanimcu,1)
		linear(2.0,p6.tv,tv.inc(1))
		smooth(2.0,p6.oneGraph,1)
		smooth(2.0,p6.animcu,1)
		end()
		smooth(0.25,p6.tourHorloge,1)
		pause()
		smooth(0.25,p6.tourHorloge,0)
		smooth(0.25,p6.txt_gen,1)
		pause()
		smooth(0.25,p6.txt_gen,2)
		pause()
		smooth(0.25,p6.txt_gen,3)
		pause()
#		smooth(0.1,p6.txt_gen,0)
		
#		smooth(0.25,p6.showanimcu,0)
#		smooth(0.5,p6.modif,1)
#		smooth(0.5,p6.modif1,1)
#		pause()
#		parallel()
#		linear(1,p6.tv,tv.inc(1))
#		linear(1,p6.rot,1)
#		end()
#		pause()
#		smooth(0.5,p6.modif1,2)
#		pause()
#		smooth(0.5,p6.modif1,3)
#		pause()
#		smooth(0.25,p6.modif1,0)
#		smooth(0.5,p6.modif2,1)
		pause()
		linear(0.5,p6.dos,1)
		parallel()
		linear(1,p6.dos,2)
		linear(1,p6.tv,tv.inc(1))
		end()
		pause()
		smooth(0.1,p6.txt_gen,0)
		
		
#		smooth(0.5,p6.modif2,2)
#		pause()
#		smooth(0.25,p6.modif2,3)
#		pause()
#		parallel()
#		smooth(0.25,p6.modif,0)
#		smooth(0.25,p6.modif2,0)
#		end()
#		smooth(0.5,p6.approche,1)
#		pause()
#		smooth(0.5,p6.fleche,1)
#		pause()
#		smooth(0.5,p6.approche,0)
#		
#		parallel()
#		smooth(0.5,p6.dos,0)
#		smooth(0.5,p6.modif,0)
#		smooth(0.5,p6.fleche,0)
#		end()
#		parallel()
#		smooth(0.25,p6.showcase,2)
#		smooth(0.25,p6.tampontxt,1)
#		end()
#		pause()
		smooth(0.25,p6.oneGraph,0)
		exit(p6)

	def Anim_memoire2():
		enter(p6)
		set(p6.build,1)
		set(p6.showclock,1)
		set(p6.colorTitle,1)
		set(p6.mode,0)
		set(p6.mode,1)
		set(p6.tv,0)
		set(p6.showcase,2)
		smooth(0.5,p6.tampontxt,1)
		pause()

		set(p6.slide2,0)
		linear(1,p6.tv,1-epsilon)
		smooth(0.25,p6.slide2,1)
		smooth(0.5,p6.fleche,1)
		set(p6.slide2,0)
		linear(1,p6.tv,2-epsilon)
		pause()
		smooth(0.25,p6.slide2,1)
		smooth(0.5,p6.fleche,0)
		
		for i in range(3,4):
			set(p6.slide2,0)
			linear(1,p6.tv,i-epsilon)
			smooth(0.25,p6.slide2,1)
		smooth(0.5,p6.death,2)
		pause()
		smooth(0.5,p6.death,1)
		for i in range(4,7):
			set(p6.slide2,0)
			linear(1,p6.tv,i-epsilon)
			smooth(0.25,p6.slide2,1)
		pause()
		
		
		parallel()
		smooth(0.25,p6.mode,0)
		smooth(0.25,p6.tampontxt,0)
		end()

		parallel()
		smooth(0.25,p6.showcase,0)
		smooth(0.25,p6.showwindow,1)
		end()
		smooth(0.5,p6.slide3,1)
		smooth(0.5,p6.title,0)
		
		exit(p6)

	def Anim_animation():
		enter(p7)
		set(p7._alpha,1)
		set(p7.showwindow,1)
		set(p7.showclock,1)
		smooth(1.0,p7.title,1)
		pause()
		smooth(0.25,p7.showstep,2)
		
		parallel()
		serial()
		smooth(0.25,p7.txtwindow,1)
		wait(1)
		smooth(0.25,p7.txtwindow,2)
		wait(1)
		smooth(0.25,p7.txt,1)
		end()
		set(p7.tv,0)
		linear(4,p7.tv,12)
		end()
		
		pause()
		smooth(0.25,p7.txt,2)
		pause()
		smooth(0.25,p7.txt,3)
		pause()
		smooth(0.25,p7.txt,4)
		smooth(0.5,p7.animeq,2)
		pause()
		smooth(0.5,p7.animeq,0)
		smooth(0.25,p7.drawnode,0)
		smooth(0.25,p7.txt,5)
		smooth(0.25,p7.drawnode,1)
		set(p7.segment,1)
		set(p7.tv,12)
		linear(2,p7.tv,12+6)
		set(p7.segment,2)
		set(p7.tv,12+6)
		linear(4,p7.tv,12+10)
		smooth(0.25,p7.life,1)
		smooth(0.25,p7.life,2)
		smooth(0.25,p7.txt,6)
		pause()
		parallel()
		smooth(0.25,p7.drawnode,0)
		smooth(0.25,p7.life,0)
		end()
		smooth(0.25,p7.txt,7)
		smooth(0.25,p7.arbrePerm,1)
		linear(1.5,p7.tv,12+15)
		pause()
		smooth(0.25,p7._alpha,0)
		exit(p7)

		enter(p15)
		smooth(0.25,p15.ti,1)
		set(p15.tooo,5)
		pause()
		smooth(0.25,p15.showtooo,1)
		pause()
		smooth(0.25,p15._alpha,0)
		exit(p15)
	
	def Anim_transition2():
		enter(p2)
		set(p2._alpha,0)
		set(p2.evaluation1,1)
		set(p2.zone,3)
		set(p2.avan,1)
		set(p2.fra,1)
		set(p2.noslide,True)
		parallel()
		smooth(0.25,p2._alpha,1)
		smooth(0.5,p2.evaluation1,0)
		end()
		pause()
		parallel()
		smooth(0.5,p2._alpha,0)
		smooth(0.5,p2.evaluation2,1)
		end()
		exit(p2)

	def Anim_rendu():
		enter(p8)
		parallel()
		smooth(0.25,p8.titletxt,1)
		smooth(0.25,p8.oneGraph,epsilon*2)
		smooth(0.25,p8.showanimcu,1)
		smooth(0.25,p8.txt,1)
		end()
		pause()
		parallel()
		smooth(4,p8.oneGraph,1)
		smooth(3,p8.animcu,1)
		end()
		pause()
		smooth(0.25,p8.showanimcu,0)
		smooth(0.25,p8.gpu,1)
		smooth(0.25,p8.txt,2)
		pause()
		wait(0.5)
		smooth(0.25,p8.echa,1)
		pause()
		smooth(0.25,p8.txt,3)
		smooth(0.25,p8.echa,2)
		wait(0.5)
		smooth(0.25,p8.echa,0)
		smooth(0.25,p8.echa2,1)
		pause()
		smooth(0.25,p8._alpha,0)
		exit(p8)
		
	def Anim_critere():
		enter(p10)
		smooth(0.25,p10.tit,1)
		pause()
		smooth(0.25,p10.txt,1)
		pause()
		parallel()
		smooth(0.25,p10.txt,2)
		smooth(0.25,p10.gra,1)
		end()
		pause()
		smooth(0.25,p10.txt,3)
		pause()
		smooth(0.25,p10.txt,4)
		pause()
		smooth(0.25,p10.txt,5)
		pause()
		parallel()
		smooth(0.25,p10.gra,0)
		smooth(0.25,p10.txt,4)
		end()
		smooth(0.25,p10.screen,1)
		pause()
		smooth(1,p10.slide1,1)
		smooth(0.25,p10._alpha,0)
		exit(p10)
		
	
	def Anim_visibilite():
		enter(p10)
		set(p10._alpha,1)
		set(p10.txt,4)
		set(p10.screen,1)
		set(p10.slide1,1)
		set(p10.slide2,0)
		smooth(1,p10.slide1,0)
		pause()
		smooth(1,p10.slide2,1)
		exit(p10)

		enter(p12)
		pause()
		smooth(0.25,p12.txt,1)
		pause()
		smooth(0.25,p12.txt,2)
		pause()
		smooth(0.25,p12.txt,3)
		pause()
		smooth(0.25,p12._alpha,0)
		exit(p12)
		
		enter(p9)
		smooth(0.25,p9._alpha,1)
		pause()
		smooth(0.25,p9.txt,1)
		pause()
		smooth(0.25,p9.txt,2)
		pause()
		smooth(0.25,p9.txt,3)
		pause()
		smooth(0.5,p9.ecran,2)
		pause()
		set(p9.nbpix,13423)
		parallel()
		smooth(0.25,p9.occ,1)
		set(p9.bb,1)
		smooth(0.25,p9.bbtxt,1)
		smooth(0.25,p9.showpix,1)
		end()
		pause()
		parallel()
		smooth(1,p9.occslide,1)
		smooth(0.8,p9.nbpix,0)
		end()
		smooth(0.25,p9.vistxt,1)
		pause()
		smooth(0.25,p9.vistxt,0)
		parallel()
		smooth(1,p9.occslide,0)
		serial()
		wait(0.2)
		smooth(0.8,p9.nbpix,13423)
		end()
		end()
#		pause()
#		smooth(0.25,p9.bb,1)
		pause()
		smooth(0.25,p9.bbtxt,2)
		smooth(0.25,p9.bb,2)
		pause()
		set(p9.bb,0)
		pause()
		smooth(0.25,p9._alpha,0)
		exit(p9)
	
	
	def Anim_visibiliteBilan():
		enter(p11)
		pause()
		smooth(0.25,p11.txt,1)
		pause()
		smooth(0.25,p11.txt,2)
		pause()
		smooth(0.25,p11.txt,3)
		smooth(0.25,p11.gra,1)
		pause()
		smooth(0.25,p11.gra,0)
		smooth(0.25,p11.txt,4)
		pause()
		smooth(0.25,p11._alpha,0)
		smooth(0.25,p11._alpha,0)
		exit(p11)
		
		enter(p10)
		set(p10._alpha,1)
		set(p10.txt,4)
		set(p10.screen,1)
		set(p10.slide1,0)
		set(p10.slide2,1)
		smooth(1,p10.slide2,0)
		pause()
		smooth(1,p10._alpha,0)
		exit(p10)
		
		enter(p2)
		set(p2._alpha,0)
		set(p2.evaluation1,1)
		set(p2.zone,3)
		set(p2.avan,1)
		set(p2.processus,1)
		set(p2.fra,1)
		set(p2.noslide,True)
		parallel()
		smooth(0.25,p2._alpha,1)
		smooth(0.5,p2.evaluation1,0)
		end()
		pause()
		smooth(0.5,p2._alpha,0)
		exit(p2)


	
	Anim_gotoDG()
	Anim_first()
	Anim_decomposition()
	Anim_modelisation()
	Anim_transition()
	Anim_evaluation()
	Anim_memoire()
	Anim_memoire2()
	Anim_animation()
	Anim_transition3()
	Anim_critere()
	Anim_precision()
	Anim_visibilite()
	Anim_rendu()
	Anim_visibiliteBilan()





def thirdPart():
	ddd=Drawable(get_camera(),DDD)
	p1=Drawable(get_camera(),lastdemo)
	p2=Drawable(get_camera(),lastccl1)
	p3=Drawable(get_camera(),lastccl2)
	
	def Anim_gotoResultat():
		enter(ddd)
		set(ddd.choice,2.0)
		set(ddd.arrow,2.0)
		set(ddd.initarrow,1.0)
		smooth(0.5,ddd.choice,2.5)
		pause()
		smooth(0.5,ddd.arrow,3.0)
		pause()
		smooth(0.5,ddd.choice,3.0)
		exit(ddd)
	
	
	#intro
	def Anim_conclusion():
		enter(p1)
		set(p1._alpha,1.0) 
		smooth(0.25,p1.build,1)
		smooth(0.25,p1.demo,1)
		pause()
		smooth(0.25,p1.demo,0)
		smooth(0.25,p1.txt,1)
		pause()
		smooth(0.25,p1.txt2,1)
		pause()
		smooth(0.25,p1.txt3,1)
		pause()
		smooth(0.25,p1._alpha,0)
		exit(p1)
		
		
		
		enter(p2)
		smooth(0.25,p2.build,1)
		smooth(0.25,p2.txt1,1)
		pause()
		smooth(0.25,p2.txt2,1)
		pause()
		smooth(0.5,p2._alpha,0.0)
		exit(p2)
		
		
		
		enter(p3)
		set(p3._alpha,1.0)
		pause()
		smooth(0.25,p3.txt1,1)
		pause()
		smooth(0.25,p3.txt2,1)
		pause()
		smooth(0.25,p3.txtt,1)
		
		parallel()
		smooth(4,p3.slide,1.0)
		serial()
		wait(1.6)
		parallel()
		smooth(0.6,p3.txt1,0)
		smooth(0.6,p3.txt2,0)
		smooth(0.6,p3.ti,0)
		end()
		end()
		end()
		enter(p2)
		set(p2.txt2,1)
		set(p2.build,1)
		parallel()
		smooth(60,p3.slide,0)
		serial()
		wait(50)
		smooth(0.5,p2._alpha,1)
		end()
		end()
		pause()
		exit(p2)
		exit(p3)
		
	
	Anim_gotoResultat()
	Anim_conclusion()






def stdplay(v):
	if v>0:
		if v>=1:
			firstPart()
		if v>=2:
			prairiePart()
		if v>=3:
			secondPart()
		if v>=4:
			thirdPart()
	if v<0:
		if -v>=4:
			firstPart()
		if -v>=3:
			prairiePart()
		if v>=2:
			secondPart()
		if -v>=1:
			thirdPart()

def go():
	
	v=4
	if "play" in localOpt:
		v=localOpt["play"]
	
	start_animation()
	stdplay(v)
#	secondPart()
#	thirdPart()
	anim=end_animation()
	
	play( anim )
	run_presentation()

go()
