
			color(coldic.font,clamp(platonic))
			text(subcanva[0]+subcanva.width()*0.5, subcanva[1]+subcanva.height()*0.85, "Platonic World [Prusinkiewicz, Gaudin]\n"  , timefont ,size=subfontSize, anchor="tc")
			color(purple,clamp(platonic-1))
			text(subcanva[0]+subcanva.width()*0.5, subcanva[1]+subcanva.height()*0.85-subfontSize*2, "\"un monde ou n'existe que ce qu'on observe\""  , timefont ,size=subfontSize*1.5, anchor="tc")
			
			txtpp="""
- gnration procdurale multi-chelle
- Modle 2D
- Langage : L-system
"""
			color(coldic.font,clamp(platonic-2))
			p=Vec2(subcanva[0]+subcanva.width()*0.1, subcanva[1]+subcanva.height()*0.5)
			text(p.x,p.y, txtpp, timefont ,size=subfontSize*1.3, anchor="cw")
			
			txtpp2="""Contributions de DynamicGraph :
- Modle 3D
- animation
- Langage : C++
"""
			color(coldic.font,clamp(platonic-3))
			text(p.x,p.y-6*subfontSize, txtpp2, timefont ,size=subfontSize*1.3, anchor="cw")



















def Complexification(
		build=(SCALAR,0.0,2.0,0.0),
		definition=(SCALAR,0.0,1.0,0.0),
		interpretation=(SCALAR,0.0,1.0,0.0),
		multi=(SCALAR,0.0,1.0,0.0),
		multicolor=(SCALAR,0.0,1.0,0.0),
		slide=(SCALAR,0.0,1.0,0.0),
		etat=(SCALAR,0.0,1.0,0.0),
		setCam=(BOOLEAN,False)
		):
	if setCam:
		set_camera(get_cams("complexification"))
	else:
		set_camera(get_cams("current"))
	canva2= get_cams("complexification")
	canva= get_cams("complexification").interp( get_cams("complexification").move_up(0.75), slide)
	fontSize=canva.height()*textSize
	color(coldic.font)
	thicknessSize=canva.height()*0.005
	thickness(thicknessSize)
	
	tbox=titleBox(canva)
	p=get_middle(tbox)
	color(coldic.font,build)
	text(p.x,p.y,"Complexification",timefont,size=canva.height()*titleSize)

	tmpbox=canva.top(0.5).inset(0.05)
	
	tmpbox=tbox.move_down(1.0).inset(0.05)
	text(tmpbox[0],tmpbox[1]+tmpbox.height()*0.8,"Principe: Partir d'une forme simple et l'enrichir progressivement lors de la modlisation", timefont, size=fontSize, anchor='cw')


	


	implybox=tmpbox.move_right(0.05).left(0.06).bottom(0.1).move_up(2)
	draw_imply(implybox,thicknessSize)
	text(implybox[0]+implybox.width()*1.6, implybox[1]+implybox.height()*0.5 ,"C'est le cas de toute modlisation", timefont, size=fontSize, anchor='cw')

	
	c=Color(coldic.font,clamp(build-1))
	r=Color(red,clamp(build-1))
	color(c)
	tmpbox=canva.bottom(0.5).inset(0.05)
	text(tmpbox[0], tmpbox[1]+tmpbox.height(),["Distinction au niveau de la ", r, "description",c," de la forme:"], timefont, size=fontSize, anchor='cw')
	text(tmpbox[0]+tmpbox.width()*0.05, tmpbox[1]+tmpbox.height()-fontSize*1.1, "- stockage du rsultat", timefont, size=fontSize, anchor='cw')
	res=text(tmpbox[0]+tmpbox.width()*0.05, tmpbox[1]+tmpbox.height()-2*fontSize*1.1, ["- stockage des ",r,"fonctions ",c,"qui engendrent le rsultat"], timefont, size=fontSize, anchor='cw')
	
	c=Color(red,clamp(build-2)).interp(Color(coldic.font,1),slide)
	color(c)
#	textRect=Rect(res["left"],res["bottom"],res["right"],res["top"]).outset(0.2)
#	textRect=scale_rect(textRect,0.9,1)
#	frame(textRect)
#	p=get_middle(textRect.move_down(2.5))
	title1="Modlisation procdurale"
	title2=" multi-chelle"

	box=titleBox(get_cams("complexification").move_down(0.75).interp( get_cams("complexification"),slide))
	middle=get_middle(box)
	
	s=fontSize*1.5*(1-slide)+slide*titleSize*canva.height()
	c=purple.interp(black,multicolor)
	text(middle.x,middle.y, ["Modlisation procdurale",c, title2[0:int(len(title2)*multi)]], timefont, size=s)
	
	
	c=Color(coldic.font,definition)
	r=Color(red,definition)
	color(c,definition)
	tmpbox=canva2.inset(0.1).top(0.1).move_down(1)
	text(tmpbox[0]-tmpbox.width()*0.1,tmpbox[1], "Description discrtise:", timefont, size=fontSize, anchor='bw')
	tmpbox=tmpbox.move_down(1)
	text(tmpbox[0],tmpbox[1], "description d'un signal par un ensemble de valeur pr-values.", timefont, size=fontSize, anchor='bw', justify=0.0, wrap=tmpbox.width())
	tmpbox=tmpbox.move_down(2)
	text(tmpbox[0]-tmpbox.width()*0.1,tmpbox[1], "Description procdurale:", timefont, size=fontSize, anchor='bw')
	tmpbox=tmpbox.move_down(1.5)
	text(tmpbox[0],tmpbox[1], ["description d'un signal par un langage complexe dont l'interprtation est",r," plus coteuse",c," mais\n",r,"plus flexible ",c, "qu'une description discrtise."], timefont, size=fontSize, anchor='bw', justify=0.0, wrap=tmpbox.width())

	color(coldic.font,interpretation)
	tmpbox=tmpbox.move_down(2)
	frame(tmpbox)
	text(tmpbox[0]+tmpbox.width()*0.1, tmpbox[1]+tmpbox.height()*0.5, ["L'valuation  lieu lors de l'observation"], timefont, size=fontSize, anchor='cw', justify=0.0, wrap=tmpbox.width())
	
#	tmpbox=tbox.move_down(1)
#	text(tmpbox[0]+tmpbox.width()*0.5, tmpbox[1]+tmpbox.height()*0.5, ["Etat de l'art : 3 catgories"], timefont, size=fontSize, anchor='cc', justify=0.0, wrap=tmpbox.width())

def Anim_complexification1():
	enter(p8)
	smooth(0.5,p8.build,2.0)
	pause()
	smooth(0.5,p8.build,3.0)
	pause()
	smooth(0.5,p8.slide,1.0)
	smooth(0.5,p8.definition,1.0)
	pause()
	smooth(0.5,p8.interpretation,1.0)
	pause()
	parallel()
	smooth(0.5,p8.definition,0.0)
	smooth(0.5,p8.interpretation,0.0)
	end()
	smooth(0.5,p8.multi,1.0)
	wait(0.2)
	smooth(0.5,p8.multicolor,1.0)
	exit(p8)











def draw_graph_main(box,ml,f):
	maxLevel=int(ml)
	if maxLevel<=0:
		maxLevel=1
		ml=1
	h=box.height()
	w=box.width()
	cs=h*0.1/ml
	firsty=box[1]+h*(1.0-0.5/maxLevel)
	firstx=box[0]+w/2
	for i in range(0,maxLevel):
		nb_leaves=pow(2,i)
		incx=1.0/nb_leaves
		decx=-incx*(nb_leaves-1)/2
		decy=float(i)/maxLevel
		if i>0:
			oldi=i-1
			old_nb_leaves=pow(2,oldi)
			old_incx=1.0/old_nb_leaves
			old_decx=-old_incx*(old_nb_leaves-1)/2
			old_decy=float(oldi)/maxLevel
		for j in range(0,nb_leaves):
			if f(incx*j):
				p=Vec2(firstx+w*(decx+incx*j),firsty-h*decy)
				circle(cs,p.x,p.y)
				if i>0:
					root=Vec2( firstx+w*(old_decx+old_incx*(j/2)), firsty-h*old_decy)
					v=root-p
					n=v.norm()
					v.scale(1/n)
					Vec2.line(p+v*cs,p+v*(n-cs))





#second page: les 5 sens
def dgFirst(
		mode=(INTEGER,0,3,2),
		precision=(SCALAR,0,1.0,0.0),
		distance=(SCALAR,0,1.0,0.5),
		rotation=(SCALAR,0,1.0,0.5)
	):
	canva=get_cams("part2")
	set_camera(canva)
	thicknessSize=canva.height()*0.005
	fontSize=canva.height()*textSize
	thickness(thicknessSize)
	color(coldic.font,1)
	
	fractalBox=canva.inset(0.3).restrict_aspect(1.0)
	
#	draw_fractal_main(fractalBox, thicknessSize, mode, precision, distance, rotation)
	draw_graph_main(mode,fractalBox,10*precision,thicknessSize*10,distance, rotation-0.5,1)
	frame(fractalBox)
#	draw_clock(get_middle(fractalBox),fractalBox.height()*0.1,30*distance)
#	color(black,1)
#	frame(fractalBox)
#	xfig=XfigFrame()
#	xfig.load("./particulier/etatart.fig")
#	xfig.set(fractalBox)
#	xfig.draw()

#	thickness(thicknessSize*0.4)
#	d=Zbuffer_precision(fractalBox)
#	d.draw(distance,precision)
#	
#	nbIm=min(int(precision*10),3)
#	if nbIm>0:
#		box_image(fractalBox,stencilImg[nbIm-1])
#	
#	draw_antibox(fractalBox.inset(0.2),black)









		random.seed(29365746535)
		coef=0.5
		rayon=box1.height()*0.4
		m=get_middle(box1)
		circle(rayon*coef*clamp(dg),m.x,m.y)
		tmparray=["prairie","foret","ocean"]
		for i in range(1,int(case)):
			a=rayon*coef*clamp(dg)
			b=rayon*(case-1-i)
			if b>rayon:
				b=rayon
			if b<0:
				continue
			angle=random.random()*6.28
			x=cos(angle)
			y=sin(angle)
			if i<len(tmparray)+1 and b>rayon*0.9:
				text(m.x+x*rayon*1.3, m.y+y*rayon*1.3, tmparray[i-1], timefont,size=subfontSize*0.5)
			draw_arrow(m.x+a*x, m.y+a*y, m.x+b*x, m.y+b*y, subthicknessSize*0.5,subthicknessSize*2)
		
		color(coldic.font,particulier*clamp(dg-1))
		text(m.x, m.y, "DG", timefont, size=rayon*coef*0.5, anchor='cc')
		text(m.x, m.y-rayon*1.5, "Factorisation\ndes tches communes", timefont, size=subfontSize, anchor='cc')




	# ZONE3
	color(coldic.font,fra*clamp(zone-2))
	text(bigBox[0]+bigBox.width()*0.5,bigBox[1]+bigBox.height()-fontSize*1.2, "Evaluation 2 : affichage", timefont, size=fontSize,anchor='bc')
	
	alpha=fra*clamp(zone-2)
	color(coldic.comment,alpha)
	thickness(thicknessSize*0.4)
	fracbox=frameArray[2].restrict_aspect(1)
#	draw_fractal_main(fracbox.inset(0.3), thicknessSize, 2, 3, -1, 1,fra*clamp(zone-2))
	Ecran(fracbox,10,1)
	color(orange,alpha)
	thickness(thicknessSize*1.2)
	frame(fracbox)
	box_image(fracbox.inset(0.2),ims["fractal"],alpha)




	if ins>epsilon:
		tmpBox=mainbox.inset(0.4).move_right(3)
		c=coldic.inst
		circle_and_text(tmpBox,"Terre",fontSize*0.5,thicknessSize,False,1,c)
		color(c,ins)
		x=tmpBox[0]+tmpBox.width()*0.5
		y=tmpBox[1]-tmpBox.height()*0.5
		draw_arrow(x, y+tmpBox.height()*5, x, y+tmpBox.height()*2, thicknessSize*3,thicknessSize*6)







	if subTitle>epsilon and root1 !=None and root2 != None:
		w=wfunc(memBox)
		tmptxt="et identifiant"
		color(coldic.font,subTitle)
		middle=get_middle(titleBox(memBox))
		text(middle.x,middle.y,[Color(coldic.font,subTitle), "Anctre ", Color(coldic.important,subTitle).interp(coldic.font,clamp(subTitle-2)), tmptxt[0:int(len(tmptxt)*clamp(subTitle-1))]], timefont, size=memBox.height()*titleSize, justify=0.5)


		memfontSize=memBox.height()*textSize
		
		dec=root2["root"].x-root1["root"].x
		lastBox=root2["firstbox"]
		proot=root2["root"]
		color(coldic.memoire,memoire)
		draw_arrow(proot.x, proot.y, proot.x-dec+w*8, proot.y, w*3, w*8)
#		text(proot.x-fontSize*3, proot.y+memfontSize, "initialisation", timefont, size=memfontSize,anchor='be')
		
		color(coldic.memoire,clamp(memoire-1))
		
		fils1=Vec2(lastBox[0]+lastBox.width()*0.75, lastBox[1]-lastBox.height()*0.5)
		fils2=Vec2(lastBox[0]-lastBox.width()*0.75+dec, lastBox[1]-lastBox.height()*0.5)
		
		draw_arrow(fils1.x, fils1.y, fils1.x-dec+w*8, fils1.y, w*3, w*8)
#		text(fils1.x-dec*0.6, fils1.y+1*memfontSize, "?", timefont, size=memfontSize*2,anchor='be')
		
		v1=fils1-proot
		n1=v1.norm()
		v1=v1*(1/n1)
		v2=Vec2(-1,0)
		n2=dec
		
		color(coldic.important,clamp(linkto*2))
		if linkto>epsilon:
			Vec2.arrow(fils1,fils1+v1*clamp(linkto-0)*(-n1+w*13),w*4)
		if linkto>1+epsilon:
			Vec2.arrow(proot,proot+v2*clamp(linkto-1)*(n2-w*13),w*4)
		if linkto>2+epsilon:
			Vec2.arrow(root1["root"], root1["root"]+ v1*clamp(linkto-2)*(n1-w*13), w*4)
		coef=clamp(memoire-2)
		
		if ide>epsilon:
			color(coldic.font,clamp(ide))
			pos=fils1
			text(pos.x,pos.y-1*memfontSize, "id=3", timefont, size=memfontSize, anchor='tc')
			pos=fils1+v2*n2
			text(pos.x,pos.y-1*memfontSize, "id=3", timefont, size=memfontSize, anchor='tc')

			color(coldic.font,clamp(ide-1))
			pos=fils2
			text(pos.x,pos.y-1*memfontSize, "id=1", timefont, size=memfontSize, anchor='tc')
			pos=fils2+v2*n2
			text(pos.x+memfontSize*1, pos.y-memfontSize*0.5, "id=1", timefont, size=memfontSize, anchor='tc')
		
		fils3=fils1*0.5+fils2*0.5
		if newide>epsilon:
			color(coldic.inst,newide)
			dot(w*6,fils3.x,fils3.y)
			color(coldic.font,clamp(ide-1))
			pos=fils3
			text(pos.x,pos.y-1*memfontSize, "id=2", timefont, size=memfontSize, anchor='tc')
			pos=fils2+v2*n2
			text(pos.x+memfontSize*1, pos.y-memfontSize*0.5, "id=2", timefont, size=memfontSize, anchor='tc')
		
		if newlinkto>epsilon:
		
			v1=fils3-proot
			n1=v1.norm()
			v1=v1*(1/n1)
			v2=Vec2(-1,0)
			n2=dec
			
			color(coldic.important,clamp(newlinkto*2))
			if newlinkto>epsilon:
				Vec2.arrow(fils3,fils3+v1*clamp(newlinkto-0)*(-n1+w*13),w*4)
			if newlinkto>1+epsilon:
				Vec2.arrow(proot,proot+v2*clamp(newlinkto-1)*(n2-w*13),w*4)
			if newlinkto>2+epsilon:
				Vec2.arrow(root1["root"], root1["root"]+ v1*clamp(newlinkto-2)*(n1-w*20), w*4)
			
			color(coldic.important,clamp(newlinkto-3))
			tmpBox=get_square(fils3+v2*dec,w*12)
			draw_cross(tmpBox,w*0.5)
			color(black,clamp(newlinkto-3))
			thickness(w*0.5)
			frame(tmpBox)
